## Shows how to use Serial remote control with a simple menu

This is a very simple menu with an example of how to configure remote control over the USB serial interface. Ethernet control is equally easy to use. Just create an ethernet instance as usual setting up IP address and MAC address and choose ethernet instead of serial in the code generator.

In order to connect using the Java API there are two possibilities, either build the example JavaFX UI that's in the main tcMenu repository, or work with the tcMenu API directly. See [https://github.com/davetcc/tcMenu]

We'll soon be writing an API in C# that is fairly much inline with the Java API. This will give even more options for using tcMenu remotely.

The files that are in this example:

* `remoteControlSerial.cpp` & `.h` are generated by the menu designer, they should not be edited, include the header file whenever you want to work with the menu items.
* `remoteControlSerial.ino` is the sketch, it will be modified by the designer as needed to add call back functions and required start up code.
* `remoteControlSerial.emf` open in the designer UI, used by the designer to store the menu structure. It is not needed at runtime, only for loading the design into the designer.
* `SerialTransport.cpp` and `.h` is the actual serial transport plug in that is copied by tcmenu into your project, do not edit is overwritten at next code generation.
* `tcMenuLiquidCrystal.cpp` and `.h` is the actual plugin for the display, do not edit will be overwritten at next code generation.
